'
#include "file.bi"
#include "fbpng.bi"
#include "fbgfx.bi"
#include once "crt.bi"

'
' Nice palette
' 1 bit for R 2 bits for G 1 bit for B

Dim As Integer i, r, g, b, c, a
Dim As uByte orgPalEntry
Dim img As any Ptr

If Len (Command (2)) <> 32 Then 
	Print "genpal.exe palout.png 32-char-pal-in-hex"
	System
End if

screenres 640, 480, 32, , -1
img = ImageCreate (128, 8, rgb (0, 0, 0))

For i = 0 To 15
	' Palette format is RRRGGGBB
	orgPalEntry = Val ("&H" & Mid (Command (2), 1 + (i * 2), 2))

	' Alpha = 255
	c = &HFF Shl 24
	
	' Extract & convert R
	c = c Or ((orgPalEntry And &HE0) Shl 16)
	
	' Extract & convert G
	c = c Or ((orgPalEntry And &H1C) Shl (8 + 3))
	
	' Extract & convert B
	c = c Or ((orgPalEntry And &H03) Shl 6)
	
	Line img, (8 * i, 0) - (7 + 8 * i, 7), c, BF
Next i

png_save (Command (1), img)
