'
#include "file.bi"
#include "fbpng.bi"
#include "fbgfx.bi"
#include once "crt.bi"

'
' Nice palette
' 1 bit for R 2 bits for G 1 bit for B

Dim As Integer i, r, g, b, c, a
Dim As uByte orgPalEntry
Dim img As any Ptr

If Len (Command (2)) <> 32 Then 
	Print "** Adjusted version **"
	Print "genpal.exe palout.png 32-char-pal-in-hex"
	System
End if

screenres 640, 480, 32, , -1
img = ImageCreate (128, 8, rgb (0, 0, 0))

For i = 0 To 15
	' Palette format is RRRGGGBB
	orgPalEntry = Val ("&H" & Mid (Command (2), 1 + (i * 2), 2))

	' Extract & convert R
	r = ((orgPalEntry And &HE0) Shr 5) * (255 / 7)
	
	' Extract & convert G
	g = ((orgPalEntry And &H1C) Shr 2) * (255 / 7)
	
	' Extract & convert B
	b = (orgPalEntry And &H03) * (255 / 3)
	
	' Store
	c = RGB (r, g, b)
	
	Line img, (8 * i, 0) - (7 + 8 * i, 7), c, BF
Next i

png_save (Command (1), img)
