// juego.c
// Esqueleto de juegos de Radastan para ZX Uno
// version 0.3c

#include <sprites.h>
#include <lib\motorzxuno.h>
#include <lib\ascii.h>

#pragma output STACKPTR=65000
int paleta [] ={0,1,7,99,4,116,12,24,13,31,64,132,180,252,221,255};

void main (void)
{
	// Variables globales
	
	int i;

	// Inicializamos el modo Radastaniano
	port_out (64571,64);
	port_out (64827,3);
	
	// Definimos la paleta
	for (i=0;i<16;++i)
	{
		escribe_paleta (i,paleta[i]);
	}

	cls (3);

	// Limite sprites x=60 e y=88
	
	for (i=0;i<61;i=i+4)
	{
		put_sprite_x8 (sprite_tile3,i,80);
		put_sprite_x8 (sprite_tile1,i,88);
	}
		put_sprite_x8 (sprite_tile2,24,72);
		put_sprite_x8 (sprite_tile3,28,72);
		put_sprite_x8 (sprite_tile4,32,72);
	
	plot (2,10,10);
	plot (4,11,10);
	plot (5,10,11);
	plot (6,11,11);

	mprint ("HOLA MUNDO!",20,10);

	put_msprite_x10 (sprite_test,30,30);

	while(1)
	{
		
	}
}
